## ros-rolling-rcl 5.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rcl)

find_package(ament_cmake_ros REQUIRED)

find_package(rcl_interfaces REQUIRED)
find_package(rcl_logging_interface REQUIRED)
find_package(rcl_yaml_param_parser REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rmw_implementation REQUIRED)
find_package(rosidl_runtime_c REQUIRED)
find_package(tracetools REQUIRED)

include(cmake/rcl_set_symbol_visibility_hidden.cmake)
include(cmake/get_default_rcl_logging_implementation.cmake)
get_default_rcl_logging_implementation(RCL_LOGGING_IMPL)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

set(${PROJECT_NAME}_sources
  src/rcl/arguments.c
  src/rcl/client.c
  src/rcl/common.c
  src/rcl/context.c
  src/rcl/domain_id.c
  src/rcl/event.c
  src/rcl/expand_topic_name.c
  src/rcl/graph.c
  src/rcl/guard_condition.c
  src/rcl/init.c
  src/rcl/init_options.c
  src/rcl/lexer.c
  src/rcl/lexer_lookahead.c
  src/rcl/localhost.c
  src/rcl/logging_rosout.c
  src/rcl/logging.c
  src/rcl/log_level.c
  src/rcl/network_flow_endpoints.c
  src/rcl/node.c
  src/rcl/node_options.c
  src/rcl/publisher.c
  src/rcl/remap.c
  src/rcl/node_resolve_name.c
  src/rcl/rmw_implementation_identifier_check.c
  src/rcl/security.c
  src/rcl/service.c
  src/rcl/subscription.c
  src/rcl/time.c
  src/rcl/timer.c
  src/rcl/validate_enclave_name.c
  src/rcl/validate_topic_name.c
  src/rcl/wait.c
)

add_library(${PROJECT_NAME} ${${PROJECT_NAME}_sources})
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")
# specific order: dependents before dependencies
ament_target_dependencies(${PROJECT_NAME}
  "rcl_interfaces"
  "rcl_logging_interface"
  "rcl_yaml_param_parser"
  "rcutils"
  "rmw"
  "rmw_implementation"
  ${RCL_LOGGING_IMPL}
  "rosidl_runtime_c"
  "tracetools"
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE "RCL_BUILDING_DLL")
rcl_set_symbol_visibility_hidden(${PROJECT_NAME} LANGUAGE "C")

if(BUILD_TESTING AND NOT RCUTILS_DISABLE_FAULT_INJECTION)
  target_compile_definitions(${PROJECT_NAME} PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
endif()

install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

# rcl_lib_dir is passed as APPEND_LIBRARY_DIRS for each ament_add_gtest call so
# the librcl that they link against is on the library path.
# This is especially important on Windows.
# This is overwritten each loop, but which one it points to doesn't really matter.
set(rcl_lib_dir "$<TARGET_FILE_DIR:${PROJECT_NAME}>")

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})

ament_export_dependencies(ament_cmake)
ament_export_dependencies(rcl_interfaces)
ament_export_dependencies(rcl_logging_interface)
ament_export_dependencies(rcl_yaml_param_parser)
ament_export_dependencies(rmw_implementation)
ament_export_dependencies(rmw)
ament_export_dependencies(rcutils)
ament_export_dependencies(${RCL_LOGGING_IMPL})
ament_export_dependencies(rosidl_runtime_c)
ament_export_dependencies(tracetools)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  add_subdirectory(test)
endif()

ament_package(CONFIG_EXTRAS "rcl-extras.cmake")

install(
  DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME}
)
install(
  DIRECTORY include/
  DESTINATION include
)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(launch_testing_ament_cmake REQUIRED)

find_package(mimick_vendor REQUIRED)
find_package(test_msgs REQUIRED)

find_package(mimick_vendor REQUIRED)

find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw_implementation_cmake REQUIRED)

find_package(osrf_testing_tools_cpp REQUIRED)

get_target_property(memory_tools_ld_preload_env_var
  osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_VARIABLE)

include(cmake/rcl_add_custom_executable.cmake)
include(cmake/rcl_add_custom_gtest.cmake)
include(cmake/rcl_add_custom_launch_test.cmake)

set(extra_lib_dirs "${rcl_lib_dir}")
add_definitions(-DTEST_RESOURCES_DIRECTORY="${CMAKE_CURRENT_SOURCE_DIR}/resources")

set(DISTRIBUTION "Unknown")
if("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")
  # If we are on Linux, look for /etc/os-release, which has "key=value" items.
  # Parse those items, looking for a key named "id" (case-insensitive), and
  # if we find it, set DISTRIBUTION to that value.  That gives us some idea
  # of which Linux distribution we are on.
  if(EXISTS "/etc/os-release")
    file(STRINGS "/etc/os-release" OS_RELEASE)
    foreach(line ${OS_RELEASE})
      string(REGEX REPLACE "^(.*)=.*" "\\1" key "${line}")
      string(TOLOWER "${key}" key)
      if("${key}" STREQUAL "id")
        string(REGEX REPLACE "^.*=(.*)" "\\1" DISTRIBUTION "${line}")
        string(TOLOWER "${DISTRIBUTION}" DISTRIBUTION)
        break()
      endif()
    endforeach()
  endif()
endif()

# finding gtest once in the highest scope
# prevents finding it repeatedly in each local scope
ament_find_gtest()

macro(test_target)
  find_package(${rmw_implementation} REQUIRED)
  test_target_function()
endmacro()

function(test_target_function)
  message(STATUS "Creating tests for '${rmw_implementation}'")
  set(rmw_implementation_env_var RMW_IMPLEMENTATION=${rmw_implementation})

  # Gtests

  rcl_add_custom_gtest(test_client${target_suffix}
    SRCS rcl/test_client.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_time${target_suffix}
    SRCS rcl/test_time.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_timer${target_suffix}
    SRCS rcl/test_timer.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_context${target_suffix}
    SRCS rcl/test_context.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_get_node_names${target_suffix}
    SRCS rcl/test_get_node_names.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_lexer${target_suffix}
    SRCS rcl/test_lexer.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_lexer_lookahead${target_suffix}
    SRCS rcl/test_lexer_lookahead.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_graph${target_suffix}
    SRCS rcl/test_graph.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
    TIMEOUT 120
  )

  rcl_add_custom_gtest(test_info_by_topic${target_suffix}
    SRCS rcl/test_info_by_topic.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} wait_for_entity_helpers
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_count_matched${target_suffix}
    SRCS rcl/test_count_matched.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_get_actual_qos${target_suffix}
    SRCS rcl/test_get_actual_qos.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "test_msgs" "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_init${target_suffix}
    SRCS rcl/test_init.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  # RHEL does not support mimick's inject_on_return functionality, which
  # causes test_node to segfault when it runs.  Since RHEL is not a Tier 1
  # platform, just disable the test since we are covering it elsewhere.
  if(
    "${DISTRIBUTION}" STREQUAL "\"centos\"" OR
    "${DISTRIBUTION}" STREQUAL "\"almalinux\"")
    set(gtest_filter_env_var "GTEST_FILTER=-TestNodeFixture__*.test_rcl_node_init_with_internal_errors")
  else()
    set(gtest_filter_env_var "")
  endif()
  rcl_add_custom_gtest(test_node${target_suffix}
    SRCS rcl/test_node.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var} ${gtest_filter_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp"
    TIMEOUT 240  # Large timeout to wait for fault injection tests
  )

  rcl_add_custom_gtest(test_arguments${target_suffix}
    SRCS rcl/test_arguments.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES "osrf_testing_tools_cpp" "rcpputils"
  )

  rcl_add_custom_gtest(test_remap${target_suffix}
    SRCS rcl/test_remap.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_remap_integration${target_suffix}
    SRCS rcl/test_remap_integration.cpp
    TIMEOUT 200
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_guard_condition${target_suffix}
    SRCS rcl/test_guard_condition.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_publisher${target_suffix}
    SRCS rcl/test_publisher.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME} mimick
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_publisher_wait_all_ack${target_suffix}
    SRCS rcl/test_publisher_wait_all_ack.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME} mimick wait_for_entity_helpers
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_service${target_suffix}
    SRCS rcl/test_service.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick wait_for_entity_helpers
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_subscription${target_suffix}
    SRCS rcl/test_subscription.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick wait_for_entity_helpers
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )
  # TODO(asorbini) Enable message timestamp tests for rmw_connextdds on Windows
  # once clock incompatibilities are resolved.
  if(rmw_implementation STREQUAL "rmw_fastrtps_cpp" OR
    rmw_implementation STREQUAL "rmw_fastrtps_dynamic_cpp" OR
    (rmw_implementation STREQUAL "rmw_connextdds" AND NOT WIN32))
    message(STATUS "Enabling message timestamp test for ${rmw_implementation}")
    target_compile_definitions(test_subscription${target_suffix}
      PUBLIC "RMW_TIMESTAMPS_SUPPORTED=1" "RMW_RECEIVED_TIMESTAMP_SUPPORTED=1")
    target_compile_definitions(test_service${target_suffix}
      PUBLIC "RMW_TIMESTAMPS_SUPPORTED=1" "RMW_RECEIVED_TIMESTAMP_SUPPORTED=1")
  else()
    if(rmw_implementation STREQUAL "rmw_cyclonedds_cpp")
      message(STATUS "Enabling only source timestamp test for ${rmw_implementation}")
      target_compile_definitions(test_subscription${target_suffix}
        PUBLIC "RMW_TIMESTAMPS_SUPPORTED=1")
      target_compile_definitions(test_service${target_suffix}
        PUBLIC "RMW_TIMESTAMPS_SUPPORTED=1")
    else()
      message(STATUS "Disabling message timestamp test for ${rmw_implementation}")
    endif()
  endif()

  rcl_add_custom_gtest(test_events${target_suffix}
    SRCS rcl/test_events.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_wait${target_suffix}
    SRCS rcl/test_wait.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_logging_rosout${target_suffix}
    SRCS rcl/test_logging_rosout.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "rcl_interfaces"
  )

  rcl_add_custom_gtest(test_namespace${target_suffix}
    SRCS test_namespace.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_rmw_impl_id_check_func${target_suffix}
    SRCS rcl/test_rmw_impl_id_check_func.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_network_flow_endpoints${target_suffix}
    SRCS rcl/test_network_flow_endpoints.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME} mimick
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

=== debian/changelog ===
ros-rolling-rcl (5.0.1-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 14 Jan 2022 08:00:00 -0000

ros-rolling-rcl (5.0.0-1focal) focal; urgency=high

  * Make rcl_difference_times args const (#955 <https://github.com/ros2/rcl/issues/955>)
  * Update inject_on_return test skipping logic (#953 <https://github.com/ros2/rcl/issues/953>)
  * Fix jump callbacks being called when zero time jump thresholds used (#948 <https://github.com/ros2/rcl/issues/948>)
  * Only change the default logger level if default_logger_level is set (#943 <https://github.com/ros2/rcl/issues/943>)
  * Add Library for wait_for_entity_helpers to deduplicate compilation (#942 <https://github.com/ros2/rcl/issues/942>)
  * Increase Windows timeout 15 -> 25 ms (#940 <https://github.com/ros2/rcl/issues/940>)
  * test should check specified number of entities. (#935 <https://github.com/ros2/rcl/issues/935>)
  * Contributors: Jafar Abdi, Scott K Logan, Shane Loretz, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 14 Dec 2021 08:00:00 -0000

ros-rolling-rcl (4.0.0-1focal) focal; urgency=high

  * Fix up documentation build for rcl when using rosdoc2 (#932 <https://github.com/ros2/rcl/issues/932>)
  * Include rmw_event_t instead of forward declaring it (#933 <https://github.com/ros2/rcl/issues/933>)
  * Contributors: Michel Hidalgo

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 16 Sep 2021 07:00:00 -0000

ros-rolling-rcl (3.2.0-1focal) focal; urgency=high

  * Add rcl_publisher_wait_for_all_acked support. (#913 <https://github.com/ros2/rcl/issues/913>)
  * Add tracing instrumentation for rcl_take. (#930 <https://github.com/ros2/rcl/issues/930>)
  * Fix #include in C++ typesupport example in rcl_subscription_init docblock. (#927 <https://github.com/ros2/rcl/issues/927>)
  * Update includes after rcutils/get_env.h deprecation. (#917 <https://github.com/ros2/rcl/issues/917>)
  * Use proper rcl_logging return value type and compare to constant. (#916 <https://github.com/ros2/rcl/issues/916>)
  * Contributors: Barry Xu, Christophe Bedard

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 02 Sep 2021 07:00:00 -0000

ros-rolling-rcl (3.1.2-1focal) focal; urgency=high

  * Fix up test_network_flow_endpoints. (#912 <https://github.com/ros2/rcl/issues/912>)
  * Contributors: Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 26 Apr 2021 07:00:00 -0000

ros-rolling-rcl (3.1.1-1focal) focal; urgency=high

  * Make test_two_timers_ready_before_timeout less flaky (#911 <https://github.com/ros2/rcl/issues/911>)
  * Add publishing instrumentation (#905 <https://github.com/ros2/rcl/issues/905>)
  * Contributors: Christophe Bedard, Ivan Santiago Paunovic

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 12 Apr 2021 07:00:00 -0000

ros-rolling-rcl (3.1.0-1focal) focal; urgency=high

  * Unique network flows (#880 <https://github.com/ros2/rcl/issues/880>)
  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#909 <https://github.com/ros2/rcl/issues/909>)
  * Add functions for waiting for publishers and subscribers (#907 <https://github.com/ros2/rcl/issues/907>)
  * Revert "Mark cyclonedds test_service test as flakey (#648 <https://github.com/ros2/rcl/issues/648>)" (#904 <https://github.com/ros2/rcl/issues/904>)
  * Guard against returning NULL or empty node names (#570 <https://github.com/ros2/rcl/issues/570>)
  * Contributors: Ananya Muddukrishna, Jacob Perron, Michel Hidalgo, shonigmann

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 06 Apr 2021 07:00:00 -0000

ros-rolling-rcl (3.0.1-1focal) focal; urgency=high

  * Remove exceptions for rmw_connext_cpp tests. (#903 <https://github.com/ros2/rcl/issues/903>)
  * Contributors: Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 25 Mar 2021 07:00:00 -0000

ros-rolling-rcl (3.0.0-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 23 Mar 2021 07:00:00 -0000

ros-rolling-rcl (2.6.0-1focal) focal; urgency=high

  * Add support for rmw_connextdds (#895 <https://github.com/ros2/rcl/issues/895>)
  * Put an argument list of 'void' where no arguments are expected. (#899 <https://github.com/ros2/rcl/issues/899>)
  * Cleanup documentation for doxygen. (#896 <https://github.com/ros2/rcl/issues/896>)
  * Contributors: Andrea Sorbini, Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 18 Mar 2021 07:00:00 -0000

ros-rolling-rcl (2.5.2-1focal) focal; urgency=high

  * Reference test resources directly from source tree (#554 <https://github.com/ros2/rcl/issues/554>)
  * Contributors: Scott K Logan

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 05 Feb 2021 08:00:00 -0000

ros-rolling-rcl (2.5.1-1focal) focal; urgency=high

  * Re-add "Improve trigger test for graph guard condition (#811 <https://github.com/ros2/rcl/issues/811>)" (#884 <https://github.com/ros2/rcl/issues/884>)
  * Revert "Improve trigger test for graph guard condition (#811 <https://github.com/ros2/rcl/issues/811>)" (#883 <https://github.com/ros2/rcl/issues/883>)
  * Move the guard condition cleanup after removing callback. (#877 <https://github.com/ros2/rcl/issues/877>)
  * Make test_subscription_nominal_string_sequence more reliable (#881 <https://github.com/ros2/rcl/issues/881>)
  * Improve trigger test for graph guard condition (#811 <https://github.com/ros2/rcl/issues/811>)
  * Add NULL check in remap.c (#879 <https://github.com/ros2/rcl/issues/879>)
  * Contributors: Barry Xu, Chris Lalancette, Ivan Santiago Paunovic, Nikolai Morin

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 25 Jan 2021 08:00:00 -0000

ros-rolling-rcl (2.5.0-1focal) focal; urgency=high

  * Add const to constant rcl_context functions (#872 <https://github.com/ros2/rcl/issues/872>)
  * Fix another failing test on CentOS 7 (#863 <https://github.com/ros2/rcl/issues/863>)
  * Update QDs to QL 1 (#866 <https://github.com/ros2/rcl/issues/866>)


=== debian/control ===
Source: ros-rolling-rcl
Section: misc
Priority: optional
Maintainer: Ivan Paunovic <ivanpauno@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake-gtest, ros-rolling-ament-cmake-ros, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-launch, ros-rolling-launch-testing, ros-rolling-launch-testing-ament-cmake, ros-rolling-mimick-vendor, ros-rolling-osrf-testing-tools-cpp, ros-rolling-rcl-interfaces, ros-rolling-rcl-logging-interface, ros-rolling-rcl-logging-spdlog, ros-rolling-rcl-yaml-param-parser, ros-rolling-rcpputils, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-rmw-implementation, ros-rolling-rmw-implementation-cmake, ros-rolling-rosidl-runtime-c, ros-rolling-test-msgs, ros-rolling-tracetools, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rcl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-rcl-interfaces, ros-rolling-rcl-logging-interface, ros-rolling-rcl-logging-spdlog, ros-rolling-rcl-yaml-param-parser, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-rmw-implementation, ros-rolling-rosidl-runtime-c, ros-rolling-tracetools, ros-rolling-ros-workspace
Description: The ROS client library common implementation.
 This package contains an API which builds on the ROS middleware API and is optionally built upon by the other ROS client libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rcl//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-rcl 7.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 find_package(ament_cmake_ros REQUIRED)
 
+find_package(libyaml_vendor REQUIRED)
 find_package(rcl_interfaces REQUIRED)
 find_package(rcl_logging_interface REQUIRED)
 find_package(rcl_yaml_param_parser REQUIRED)
@@ -11,7 +12,10 @@
 find_package(rmw REQUIRED)
 find_package(rmw_implementation REQUIRED)
 find_package(rosidl_runtime_c REQUIRED)
+find_package(service_msgs REQUIRED)
 find_package(tracetools REQUIRED)
+find_package(type_description_interfaces REQUIRED)
+find_package(yaml REQUIRED)
 
 include(cmake/rcl_set_symbol_visibility_hidden.cmake)
 include(cmake/get_default_rcl_logging_implementation.cmake)
@@ -22,9 +26,10 @@
   set(CMAKE_C_STANDARD 11)
 endif()
 
-# Default to C++14
+# Default to C++17
 if(NOT CMAKE_CXX_STANDARD)
-  set(CMAKE_CXX_STANDARD 14)
+  set(CMAKE_CXX_STANDARD 17)
+  set(CMAKE_CXX_STANDARD_REQUIRED ON)
 endif()
 
 if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
@@ -36,7 +41,9 @@
   src/rcl/client.c
   src/rcl/common.c
   src/rcl/context.c
+  src/rcl/discovery_options.c
   src/rcl/domain_id.c
+  src/rcl/dynamic_message_type_support.c
   src/rcl/event.c
   src/rcl/expand_topic_name.c
   src/rcl/graph.c
@@ -52,15 +59,19 @@
   src/rcl/network_flow_endpoints.c
   src/rcl/node.c
   src/rcl/node_options.c
+  src/rcl/node_type_cache.c
   src/rcl/publisher.c
   src/rcl/remap.c
   src/rcl/node_resolve_name.c
   src/rcl/rmw_implementation_identifier_check.c
   src/rcl/security.c
   src/rcl/service.c
+  src/rcl/service_event_publisher.c
   src/rcl/subscription.c
   src/rcl/time.c
   src/rcl/timer.c
+  src/rcl/type_hash.c
+  src/rcl/type_description_conversions.c
   src/rcl/validate_enclave_name.c
   src/rcl/validate_topic_name.c
   src/rcl/wait.c
@@ -69,19 +80,33 @@
 add_library(${PROJECT_NAME} ${${PROJECT_NAME}_sources})
 target_include_directories(${PROJECT_NAME} PUBLIC
   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
-  "$<INSTALL_INTERFACE:include>")
-# specific order: dependents before dependencies
-ament_target_dependencies(${PROJECT_NAME}
-  "rcl_interfaces"
-  "rcl_logging_interface"
-  "rcl_yaml_param_parser"
-  "rcutils"
-  "rmw"
-  "rmw_implementation"
-  ${RCL_LOGGING_IMPL}
-  "rosidl_runtime_c"
-  "tracetools"
+  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>"
+  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
+target_link_libraries(${PROJECT_NAME} PUBLIC
+  # TODO(clalancette): rcl_interfaces should be PRIVATE, but downstream depends on it for now
+  ${rcl_interfaces_TARGETS}
+  # TODO(clalancette): rcl_logging_interface should be PRIVATE, but downstream depends on it for now
+  rcl_logging_interface::rcl_logging_interface
+  rcl_yaml_param_parser::rcl_yaml_param_parser
+  rcutils::rcutils
+  rmw::rmw
+  # TODO(clalancette): rmw_implementation should be PRIVATE, but downstream depends on it for now
+  rmw_implementation::rmw_implementation
+  rosidl_runtime_c::rosidl_runtime_c
+  ${type_description_interfaces_TARGETS}
 )
+target_link_libraries(${PROJECT_NAME} PRIVATE
+  ${RCL_LOGGING_IMPL}::${RCL_LOGGING_IMPL}
+  ${service_msgs_TARGETS}
+  tracetools::tracetools
+  yaml
+)
+
+# Allow configuring the default discovery range
+if(DEFINED RCL_DEFAULT_DISCOVERY_RANGE)
+target_compile_definitions(${PROJECT_NAME} PRIVATE
+  "RCL_DEFAULT_DISCOVERY_RANGE=${RCL_DEFAULT_DISCOVERY_RANGE}")
+endif()
 
 # Causes the visibility macros to use dllexport rather than dllimport,
 # which is appropriate when building the dll but not consuming it.
@@ -104,21 +129,24 @@
 # This is overwritten each loop, but which one it points to doesn't really matter.
 set(rcl_lib_dir "$<TARGET_FILE_DIR:${PROJECT_NAME}>")
 
-# specific order: dependents before dependencies
-ament_export_include_directories(include)
+# Export old-style CMake variables
+ament_export_include_directories("include/${PROJECT_NAME}")
 ament_export_libraries(${PROJECT_NAME})
+# Export modern CMake targets
 ament_export_targets(${PROJECT_NAME})
 
 ament_export_dependencies(ament_cmake)
+# TODO(clalancette): rcl_interfaces shouldn't be exported, but downstream depends on it for now
 ament_export_dependencies(rcl_interfaces)
+# TODO(clalancette): rcl_logging_interface shouldn't be exported, but downstream depends on it for now
 ament_export_dependencies(rcl_logging_interface)
 ament_export_dependencies(rcl_yaml_param_parser)
+ament_export_dependencies(rcutils)
+ament_export_dependencies(rmw)
+# TODO(clalancette): rmw_implementation shouldn't be exported, but downstream depends on it for now
 ament_export_dependencies(rmw_implementation)
-ament_export_dependencies(rmw)
-ament_export_dependencies(rcutils)
-ament_export_dependencies(${RCL_LOGGING_IMPL})
 ament_export_dependencies(rosidl_runtime_c)
-ament_export_dependencies(tracetools)
+ament_export_dependencies(type_description_interfaces)
 
 if(BUILD_TESTING)
   find_package(ament_lint_auto REQUIRED)
@@ -135,5 +163,5 @@
 )
 install(
   DIRECTORY include/
-  DESTINATION include
+  DESTINATION include/${PROJECT_NAME}
 )

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,13 @@
 find_package(ament_cmake_gtest REQUIRED)
+
 find_package(launch_testing_ament_cmake REQUIRED)
-
 find_package(mimick_vendor REQUIRED)
-find_package(test_msgs REQUIRED)
-
-find_package(mimick_vendor REQUIRED)
-
+find_package(osrf_testing_tools_cpp REQUIRED)
 find_package(rcpputils REQUIRED)
 find_package(rcutils REQUIRED)
 find_package(rmw_implementation_cmake REQUIRED)
-
-find_package(osrf_testing_tools_cpp REQUIRED)
+find_package(rosidl_runtime_cpp REQUIRED)
+find_package(test_msgs REQUIRED)
 
 get_target_property(memory_tools_ld_preload_env_var
   osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_VARIABLE)
@@ -65,14 +62,6 @@
     AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
   )
 
-  rcl_add_custom_gtest(test_time${target_suffix}
-    SRCS rcl/test_time.cpp
-    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
-    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
-    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
-    AMENT_DEPENDENCIES ${rmw_implementation}
-  )
-
   rcl_add_custom_gtest(test_timer${target_suffix}
     SRCS rcl/test_timer.cpp
     ENV ${rmw_implementation_env_var}
@@ -91,22 +80,6 @@
 
   rcl_add_custom_gtest(test_get_node_names${target_suffix}
     SRCS rcl/test_get_node_names.cpp
-    ENV ${rmw_implementation_env_var}
-    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
-    LIBRARIES ${PROJECT_NAME}
-    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp"
-  )
-
-  rcl_add_custom_gtest(test_lexer${target_suffix}
-    SRCS rcl/test_lexer.cpp
-    ENV ${rmw_implementation_env_var}
-    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
-    LIBRARIES ${PROJECT_NAME}
-    AMENT_DEPENDENCIES ${rmw_implementation}
-  )
-
-  rcl_add_custom_gtest(test_lexer_lookahead${target_suffix}
-    SRCS rcl/test_lexer_lookahead.cpp
     ENV ${rmw_implementation_env_var}
     APPEND_LIBRARY_DIRS ${extra_lib_dirs}
     LIBRARIES ${PROJECT_NAME}
@@ -173,15 +146,6 @@
     TIMEOUT 240  # Large timeout to wait for fault injection tests
   )
 
-  rcl_add_custom_gtest(test_arguments${target_suffix}
-    SRCS rcl/test_arguments.cpp
-    ENV ${rmw_implementation_env_var}
-    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
-    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
-    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
-    AMENT_DEPENDENCIES "osrf_testing_tools_cpp" "rcpputils"
-  )
-
   rcl_add_custom_gtest(test_remap${target_suffix}
     SRCS rcl/test_remap.cpp
     ENV ${rmw_implementation_env_var}
@@ -223,7 +187,12 @@
     APPEND_LIBRARY_DIRS ${extra_lib_dirs}
     INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
     LIBRARIES ${PROJECT_NAME} mimick wait_for_entity_helpers
-    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
+    AMENT_DEPENDENCIES ${rmw_implementation}
+      "osrf_testing_tools_cpp"
+      "rcpputils"
+      "rcutils"
+      "rosidl_runtime_c"
+      "test_msgs"
   )
 
   rcl_add_custom_gtest(test_service${target_suffix}
@@ -239,7 +208,11 @@
     ENV ${rmw_implementation_env_var}
     APPEND_LIBRARY_DIRS ${extra_lib_dirs}
     LIBRARIES ${PROJECT_NAME} mimick wait_for_entity_helpers
-    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
+    AMENT_DEPENDENCIES ${rmw_implementation}
+      "osrf_testing_tools_cpp"
+      "rosidl_runtime_cpp"
+      "test_msgs"
+    TIMEOUT 120
   )
   # TODO(asorbini) Enable message timestamp tests for rmw_connextdds on Windows
   # once clock incompatibilities are resolved.
@@ -289,7 +262,7 @@
   )
 
   rcl_add_custom_gtest(test_namespace${target_suffix}
-    SRCS test_namespace.cpp
+    SRCS rcl/test_namespace.cpp
     ENV ${rmw_implementation_env_var}
     APPEND_LIBRARY_DIRS ${extra_lib_dirs}
     LIBRARIES ${PROJECT_NAME}
@@ -313,3 +286,29 @@
     AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
   )
 
+  rcl_add_custom_gtest(test_service_event_publisher${target_suffix}
+    SRCS rcl/test_service_event_publisher.cpp
+    ENV ${rmw_implementation_env_var}
+    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
+    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
+    LIBRARIES ${PROJECT_NAME} mimick wait_for_entity_helpers
+    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
+  )
+
+  rcl_add_custom_gtest(test_type_description_conversions${target_suffix}
+    SRCS rcl/test_type_description_conversions.cpp
+    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
+    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
+    LIBRARIES ${PROJECT_NAME}
+    AMENT_DEPENDENCIES "test_msgs"
+  )
+
+  rcl_add_custom_gtest(test_node_type_cache${target_suffix}
+    SRCS rcl/test_node_type_cache.cpp
+    ENV ${rmw_implementation_env_var}
+    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
+    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
+    LIBRARIES ${PROJECT_NAME} mimick
+    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
+  )
+

=== debian/changelog ===
ros-rolling-rcl (7.1.1-1jammy) jammy; urgency=high

  * Cut down the amount of time for test_logging_rosout. (#1098 <https://github.com/ros2/rcl/issues/1098>)
  * Simplify local_namespace handling in rcl_node_init. (#1097 <https://github.com/ros2/rcl/issues/1097>)
  * Reduce the number of tests we run (#1096 <https://github.com/ros2/rcl/issues/1096>)
  * Adding duplicate node information (#1088 <https://github.com/ros2/rcl/issues/1088>)
  * Revamp the test_get_type_description_service. (#1095 <https://github.com/ros2/rcl/issues/1095>)
  * Cleanup network flow endpoints test. (#1094 <https://github.com/ros2/rcl/issues/1094>)
  * Reduce the failure timeout time for namespaces. (#1093 <https://github.com/ros2/rcl/issues/1093>)
  * Shorten wait time for a subscription not being ready. (#1092 <https://github.com/ros2/rcl/issues/1092>)
  * Contributors: Chris Lalancette, Lucas Wendland

 -- Audrow Nash <audrow@openrobotics.org>  Thu, 07 Sep 2023 00:00:00 -0000

ros-rolling-rcl (7.1.0-1jammy) jammy; urgency=high

  * rcl_send_response returns RCL_RET_TIMEOUT. (#1048 <https://github.com/ros2/rcl/issues/1048>)
  * Move test_namespace into the correct directory. (#1087 <https://github.com/ros2/rcl/issues/1087>)
  * Reset errors in tests to reduce warnings (#1085 <https://github.com/ros2/rcl/issues/1085>)
  * Cleanup error reporting in the type hash code. (#1084 <https://github.com/ros2/rcl/issues/1084>)
  * Instrument loaned message publication code path (#1083 <https://github.com/ros2/rcl/issues/1083>)
  * Contributors: Chris Lalancette, Christophe Bedard, Tomoya Fujita

 -- Audrow Nash <audrow@openrobotics.org>  Mon, 21 Aug 2023 00:00:00 -0000

ros-rolling-rcl (7.0.0-1jammy) jammy; urgency=high

  * Add ~/get_type_description service (rep2011) (#1052 <https://github.com/ros2/rcl/issues/1052>)
  * Modifies timers API to select autostart state (#1004 <https://github.com/ros2/rcl/issues/1004>)
  * test publisher/subscription with the c/cpp typesupport for test_msgs::msg::array (#1074 <https://github.com/ros2/rcl/issues/1074>)
  * validation result should be used to print the error message. (#1077 <https://github.com/ros2/rcl/issues/1077>)
  * Contributors: Chen Lihui, Eloy Briceno, Hans-Joachim Krauch, Tomoya Fujita

 -- Audrow Nash <audrow@openrobotics.org>  Tue, 11 Jul 2023 00:00:00 -0000

ros-rolling-rcl (6.3.0-1jammy) jammy; urgency=high

  * improve error msg of rcl_expand_topic_name (#1076 <https://github.com/ros2/rcl/issues/1076>)
  * Use TRACETOOLS_ prefix for tracepoint-related macros (#1058 <https://github.com/ros2/rcl/issues/1058>)
  * Contributors: Christophe Bedard, Eric W

 -- Audrow Nash <audrow@openrobotics.org>  Mon, 12 Jun 2023 00:00:00 -0000

ros-rolling-rcl (6.2.0-1jammy) jammy; urgency=high

  * fix comment (#1073 <https://github.com/ros2/rcl/issues/1073>)
  * localhost_only prevails auto discovery options if enabled. (#1069 <https://github.com/ros2/rcl/issues/1069>)
  * Avoid dynamic allocation of message before sending over rosout (#1067 <https://github.com/ros2/rcl/issues/1067>)
  * Contributors: Chen Lihui, Christopher Wecht, Tomoya Fujita

 -- Audrow Nash <audrow@openrobotics.org>  Wed, 07 Jun 2023 00:00:00 -0000

ros-rolling-rcl (6.1.1-1jammy) jammy; urgency=high

  * clarify rcl_node_init return code (#1066 <https://github.com/ros2/rcl/issues/1066>)
  * Contributors: Eric W

 -- Audrow Nash <audrow@openrobotics.org>  Thu, 11 May 2023 00:00:00 -0000

ros-rolling-rcl (6.1.0-1jammy) jammy; urgency=high

  * Fix a format-security warning when building with clang. (#1064 <https://github.com/ros2/rcl/issues/1064>)
  * Contributors: Chris Lalancette

 -- Audrow Nash <audrow@openrobotics.org>  Fri, 28 Apr 2023 00:00:00 -0000

ros-rolling-rcl (6.0.1-1jammy) jammy; urgency=high

  * fix flaky test (#1063 <https://github.com/ros2/rcl/issues/1063>)
  * Contributors: Chen Lihui

 -- Audrow Nash <audrow@openrobotics.org>  Tue, 18 Apr 2023 00:00:00 -0000

ros-rolling-rcl (6.0.0-1jammy) jammy; urgency=high

  * Add enable_type_description_service node option - API only (#1060 <https://github.com/ros2/rcl/issues/1060>)
  * Dynamic Subscription (BONUS: Allocators): rcl (#1057 <https://github.com/ros2/rcl/issues/1057>)
  * Runtime Interface Reflection: rcl (#1025 <https://github.com/ros2/rcl/issues/1025>)
  * [rcl] Improve handling of dynamic discovery  (#1023 <https://github.com/ros2/rcl/issues/1023>)
  * Use get_type_hash_func for typesupports (#1055 <https://github.com/ros2/rcl/issues/1055>)
  * publish for rosout topic multiple times to avoid flaky test (#1054 <https://github.com/ros2/rcl/issues/1054>)
  * Switch to target_link_libraries in rcl. (#1051 <https://github.com/ros2/rcl/issues/1051>)
  * Calculate type hash from TypeDescription (rep2011) (#1027 <https://github.com/ros2/rcl/issues/1027>)
  * Implement matched event (#1033 <https://github.com/ros2/rcl/issues/1033>)
  * use user-defined allocator to configure logging. (#1047 <https://github.com/ros2/rcl/issues/1047>)
  * user defined allocator should be used for rosout publisher. (#1044 <https://github.com/ros2/rcl/issues/1044>)
  * Add in inconsistent_topic implementation. (#1024 <https://github.com/ros2/rcl/issues/1024>)
  * doc update, ROS message accessibility depends on RMW implementation. (#1043 <https://github.com/ros2/rcl/issues/1043>)
  * Fix some warnings from clang. (#1042 <https://github.com/ros2/rcl/issues/1042>)
  * avoid unnecessary copy for rcutils_char_array_vsprintf. (#1035 <https://github.com/ros2/rcl/issues/1035>)
  * Contributors: Barry Xu, Chen Lihui, Chris Lalancette, Emerson Knapp, Geoffrey Biggs, Tomoya Fujita, methylDragon

 -- Audrow Nash <audrow@openrobotics.org>  Wed, 12 Apr 2023 00:00:00 -0000

ros-rolling-rcl (5.9.0-1jammy) jammy; urgency=high

  * Service introspection (#997 <https://github.com/ros2/rcl/issues/997>)
  * Cache disable flag to avoid reading environmental variable. (#1029 <https://github.com/ros2/rcl/issues/1029>)
  * Contributors: Brian, Tomoya Fujita



=== debian/control ===
Source: ros-rolling-rcl
Section: misc
Priority: optional
Maintainer: Audrow Nash <audrow@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libyaml-dev, ros-rolling-ament-cmake-gtest <!nocheck>, ros-rolling-ament-cmake-ros, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-launch <!nocheck>, ros-rolling-launch-testing <!nocheck>, ros-rolling-launch-testing-ament-cmake <!nocheck>, ros-rolling-libyaml-vendor, ros-rolling-mimick-vendor <!nocheck>, ros-rolling-osrf-testing-tools-cpp <!nocheck>, ros-rolling-rcl-interfaces, ros-rolling-rcl-logging-interface, ros-rolling-rcl-logging-spdlog, ros-rolling-rcl-yaml-param-parser, ros-rolling-rcpputils <!nocheck>, ros-rolling-rcutils, ros-rolling-rmw <!nocheck>, ros-rolling-rmw-implementation, ros-rolling-rmw-implementation-cmake <!nocheck>, ros-rolling-rosidl-runtime-c, ros-rolling-rosidl-runtime-cpp <!nocheck>, ros-rolling-service-msgs, ros-rolling-test-msgs <!nocheck>, ros-rolling-tracetools, ros-rolling-type-description-interfaces, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rcl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libyaml-dev, ros-rolling-libyaml-vendor, ros-rolling-rcl-interfaces, ros-rolling-rcl-logging-interface, ros-rolling-rcl-logging-spdlog, ros-rolling-rcl-yaml-param-parser, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-rmw-implementation, ros-rolling-rosidl-runtime-c, ros-rolling-service-msgs, ros-rolling-tracetools, ros-rolling-type-description-interfaces, ros-rolling-ros-workspace
Description: The ROS client library common implementation.
 This package contains an API which builds on the ROS middleware API and is optionally built upon by the other ROS client libraries.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
